#
#                         *  BOOH  *
#
# A.k.a `Best web-album Of the world, Or your money back, Humerus'.
#
# The acronyn sucks, however this is a tribute to Dragon Ball by
# Akira Toriyama, where the last enemy beaten by heroes of Dragon
# Ball is named "Boo". But there was already a free software project
# called Boo, so this one will be it "Booh". Or whatever.
#
#
# Copyright (c) 2004 Guillaume Cottenceau <gc3 at bluewin.ch>
#
# This software may be freely redistributed under the terms of the GNU
# public license version 2.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# holds static data to merge in the html "themes"

require 'gettext'
bindtextdomain("booh")

require 'booh/booh-lib'
require 'booh/version.rb'
include Booh

$image_head_code = '<meta name="generator" content="Booh-' + $VERSION + <<'EOF'
 http://booh.org/"/>

<script language="JavaScript1.1" type="text/JavaScript">
var images = new Array(~~images~~);
~~other_images~~
var thumbnailspages = new Array(~~thumbnailspages~~);
var other_sizes = new Array(~~other_sizes~~);
var captions = new Array(~~captions~~);

var images_ary = new Array();
var images_loaded = new Array();
var current = 0;
var slideshow = 0;
var slideshow_pause = null;
var slideshow_timer = null;

for (i = 0; i < images.length; i++) { 
    /* this array will contain 0 if image not yet loaded, 1 when loading,
     * 2 when complete */
    images_loaded[i] = 0;
}

function dbg(t) {
    document.getElementById('dbg_text').innerHTML += t + "\n";
}

/* load image, return 1 if image is finished loading */
function load(i) {
    if (images_loaded[i] == 0) {
        images_ary[i] = new Image();
        images_ary[i].src = images[i];
        images_loaded[i] = 1;
    }
    if (images_loaded[i] == 1) {
        if (images_ary[i].complete) {
            images_loaded[i] = 2;
        } else {
            return 0;
        }
    }
    return 1;
}

function getparam(key) {
    all_params = location.href.split("#")
    if (all_params.length > 1) {
        params = all_params[1].split("&");
        for (i = 0; i < params.length; i++) {
            keyvalue = params[i].split("=");
            if (keyvalue[0] == key) {
                return keyvalue[1];
            }
        }
    }
    return null;
}

function loadcurrent(img) {
    for (i = 0; i < images.length; i++) {
        if (images[i] == img) {
            current = i;
            display_current();
            return;
        }
    }
    current = 0;
    display_current();
}

function browser_href() {
    all = location.href.split("/");
    return all[all.length - 1];
}

/* check URL for changes; allows the URL to reflect currently showed image */
var currentURL = '';
function checkURL() {
    if (currentURL == 'ignore1') {
        // do nothing
    } else if (currentURL == 'ignore2') {
        currentURL = browser_href();
    } else {
        href = browser_href();
        if (href != currentURL) {
            currentURL = href;
            img = getparam('current');
            loadcurrent(img);
        }
    }
    setTimeout("checkURL()", 100);
}

function preload() { 

    /* favor current image, if user clicked on `last' or something */
    load(current);

    /* don't blindly preload all images at the beginning,
     * but rather load them one by one, in order to get
     * next ones faster, beginning with next to current
     */
    if (current + 1 < images.length && load(current + 1) == 0) {
        setTimeout("preload()", 500);
        return;
    }
    if (current - 1 >= 0 && load(current - 1) == 0) {
        setTimeout("preload()", 500);
        return;
    }

    for (i = current + 2; i < images.length && i <= current + 5; i++) { 
        if (load(i) == 0) {
            setTimeout("preload()", 500);
            return;
        }
    }
    for (i = current - 2; i >= current - 3; i--) { 
        if (i >= 0) {
            if (load(i) == 0) {
                setTimeout("preload()", 500);
                return;
            }
        }
    }

    setTimeout("preload()", 500);
}

function add_cookie(val) {
    var expires = new Date(new Date().getTime() + (30 * 86400000));  // 30 days
    document.cookie = val
                      + '; expires=' + expires.toGMTString()
                      + '; path=/';
}

function get_cookie(key) {
    if (document.cookie) {
        var index = document.cookie.indexOf(key);
        if (index != -1) {
            var oleft = (document.cookie.indexOf('=', index) + 1);
            var oright = document.cookie.indexOf(';', index);
            if (oright == -1) {
                oright = document.cookie.length;
            }
            return document.cookie.substring(oleft, oright);
        }
    }
    return null;
}

function init() {

    preferred_pause = get_cookie('booh-slideshow-pause-~~theme~~');
    if (preferred_pause != null) {
        document.getElementById('secs').value = preferred_pause;
    }

    if (getparam('run_slideshow')) {
        toggle_slideshow();
    }

    checkURL();

    preload();
    if (images.length == 1) {
        document.getElementById("b_slideshow").disabled = true;
        document.getElementById("b_slideshow").setAttribute("class", "disabled");
    }

    if (navigator.userAgent.indexOf('Opera') == -1) {
        document.onkeydown = keyDownEvent;
    }
}

function update_sensibilities() {
    if (current == 0) {
        document.getElementById("b_first").disabled = true;
        document.getElementById("b_previous").disabled = true;
        document.getElementById("b_first").setAttribute("class", "disabled");
        document.getElementById("b_previous").setAttribute("class", "disabled");
    } else {
        document.getElementById("b_first").disabled = false;
        document.getElementById("b_previous").disabled = false;
        document.getElementById("b_first").removeAttribute("class");
        document.getElementById("b_previous").removeAttribute("class");
    }

    if (current == images.length - 1) {
        document.getElementById("b_next").disabled = true;
        document.getElementById("b_last").disabled = true;
        document.getElementById("b_next").setAttribute("class", "disabled");
        document.getElementById("b_last").setAttribute("class", "disabled");
    } else {
        document.getElementById("b_next").disabled = false;
        document.getElementById("b_last").disabled = false;
        document.getElementById("b_next").removeAttribute("class");
        document.getElementById("b_last").removeAttribute("class");
    }
}

function set_cursor_(value, element) {

    if (!element || !element.style) {
        return;
    }

    element.style.cursor = value;

    children = element.childNodes;
    for (i = 0; i < children.length; i++) {
        set_cursor_(value, children.item[i]);
    }
}

function set_cursor(value) {
    set_cursor_(value, document.getElementById('body'));
    set_cursor_(value, document.getElementById('b_first'));
    set_cursor_(value, document.getElementById('b_previous'));
    set_cursor_(value, document.getElementById('b_next'));
    set_cursor_(value, document.getElementById('b_last'));
}

function show_current_text() {
    /* don't show text if image not yet loaded because navigator
     * won't refresh it during load */
    if (images_loaded[current] == 2) {
        document.getElementById('image_counter').innerHTML = ( current + 1 ) + "/" + images.length;
        document.getElementById('main_text').innerHTML = captions[current];
        for (i = 0; i < other_sizes.length; i++) { 
            if (other_sizes[i] == "original") {
                document.getElementById('link' + other_sizes[i]).href = eval("images_" + other_sizes[i] + "[current]");
            } else {
                document.getElementById('link' + other_sizes[i]).href = 'image-' + other_sizes[i] + '.html#current=' + eval("images_" + other_sizes[i] + "[current]");
            }
        }
        document.getElementById('thumbnails').href = 'thumbnails-~~current_size~~-' + thumbnailspages[current] + '.html#' + images[current];
        set_cursor("default");
    } else {
        setTimeout("show_current_text()", 100);
        set_cursor("wait");
    }
}

function display_current() {
    document.main_img.src = images[current];
    oldhref = browser_href();
    newhref = 'image-~~current_size~~.html#current=' + images[current];
    if (oldhref != newhref) {
        currentURL = 'ignore1';
        location.href = newhref;
        currentURL = 'ignore2';
    }
    show_current_text();
    update_sensibilities();
}

function first() {
    if (slideshow == 1) {
        toggle_slideshow(true);
    }
    
    current = 0;
    display_current();
}

function next() {
    if (slideshow == 1) {
        toggle_slideshow(true);
    }

    if (current < images.length - 1) {
        current++;
        display_current();
    }
}

function next10() {
    if (slideshow == 1) {
        toggle_slideshow(true);
    }

    if (current < images.length - 11) {
        current += 10;
    } else {
        current = images.length - 1;
    }
    display_current();
}

function previous() {
    if (slideshow == 1) {
        toggle_slideshow(true);
    }

    if (current > 0) {
        current--;
        display_current();
    }
}

function previous10() {
    if (slideshow == 1) {
        toggle_slideshow(true);
    }

    if (current > 10) {
        current -= 10;
    } else {
        current = 0;
    }
    display_current();
}

function last() {
    if (slideshow == 1) {
        toggle_slideshow(true);
    }

    current = images.length - 1;
    display_current();
}

function keyDownEvent(key) {
    if (!key) {
        key = event;
        key.which = key.keyCode;
    }
    if (key.altKey || key.ctrlKey || key.shiftKey) {
        return;
    }
    switch (key.which) {
      case 36: // home
        first();
        break;
      case 35: // end
        last();
        break;
      case 37: // left
        previous();
        break;
      case 39: // right
        next();
        break;
      case 38: // up
        previous10();
        break;
      case 40: // down
        next10();
        break;
    }
}

function toggle_slideshow(now) {
    if (slideshow == 0) {
        slideshow_pause = document.getElementById('secs').value;
        add_cookie('booh-slideshow-pause-~~theme~~=' + slideshow_pause)
        document.getElementById("b_slideshow").value = "~~stop_slideshow~~";
        slideshow = 1;
        if (current == images.length - 1) {
            current = -1;
        }
        if (now) {
            run_slideshow();
        } else {
            setTimeout("run_slideshow()", slideshow_pause * 1000);
        }
    } else {
        clearTimeout(slideshow_timer);
        document.getElementById("b_slideshow").value = "~~run_slideshow~~";
        slideshow = 0;
    }
}

function run_slideshow() {
    if (slideshow == 0) {
        return;
    }

    if (images_loaded[current + 1] == 2) {
        current++;
        display_current();
        slideshow_timer = setTimeout("run_slideshow()", slideshow_pause * 1000);
    } else {
        slideshow_timer = setTimeout("run_slideshow()", 500);
    }

    if (current == images.length - 1) {
        toggle_slideshow(true);
    }
}

function set_preferred_size(val) {
    var expires = new Date(new Date().getTime() + (30 * 86400000));  // 30 days
    document.cookie = 'booh-preferred-size-~~theme~~='
                      + val
                      + '; expires=' + expires.toGMTString()
                      + '; path=/';
}
</script>
EOF

$image_head_code.sub!('~~run_slideshow~~', utf8(_('Run slideshow!')))
$image_head_code.sub!('~~stop_slideshow~~', utf8(_('Stop slideshow')))

$body_additions = <<'EOF'
onload="init()" id="body"
EOF

$button_first = '
    <form action="fake"><input type="button"
                 onclick="first()"
                 value="' + utf8(_('<<- First')) + '"
                 id="b_first"/></form>'

$button_previous = '
    <form action="fake"><input type="button"
                 onclick="previous()"
                 value="' + utf8(_('<- Previous')) + '"
                 id="b_previous"/></form>'

$button_next = '
    <form action="fake"><input type="button"
                 onclick="next()"
                 value="' + utf8(_('Next ->')) + '"
                 id="b_next"/></form>'

$button_last = '
    <form action="fake"><input type="button"
                 onclick="last()"
                 value="' + utf8(_('Last ->>')) + '"
                 id="b_last"/></form>'

$button_slideshow = '
    <input type="button"
           onclick="toggle_slideshow(true)"
           value="' + utf8(_('Run slideshow!')) + '"
           id="b_slideshow"/>'

$pause_slideshow = '
    <font size="-2">' + utf8(_('pause:')) + '<input type="text" id="secs" size="1" value="3"/>' + utf8(_('secs')) + '</font>'


$image = <<'EOF'
  <img name="main_img" src="fake" alt="main image"/>
EOF

$image_counter_additions = <<'EOF'
  id="image_counter"
EOF

$caption_additions = <<'EOF'
  id="main_text"
EOF

$body_code = <<'EOF'
EOF


$thumbnails_head_code = '<meta name="generator" content="Booh-' + $VERSION + <<'EOF'
 http://booh.org/"/>

<script language="JavaScript1.1" type="text/JavaScript">
function set_preferred_size(val) {
    var expires = new Date(new Date().getTime() + (30 * 86400000));  // 30 days
    document.cookie = 'booh-preferred-size-~~theme~~='
                      + val
                      + '; expires=' + expires.toGMTString()
                      + '; path=/';
}
</script>
EOF


$preferred_size_reloader = <<'EOF'
<html>
    <body>
    </body>
        <script language="JavaScript1.1" type="text/JavaScript">

var sizes = new Array(~~all_sizes~~);

function getPreferredSize() {
    if (document.cookie) {
        var index = document.cookie.indexOf('booh-preferred-size-~~theme~~');
        if (index != -1) {
            var oleft = (document.cookie.indexOf('=', index) + 1);
            var oright = document.cookie.indexOf(';', index);
            if (oright == -1) {
                oright = document.cookie.length;
            }
            size = document.cookie.substring(oleft, oright);
            for (i = 0; i < sizes.length; i++) {
                if (sizes[i] == size) {
                    return 'thumbnails-' + size + '-0.html';
                }
            }
        }
    }
    w = document.body.offsetWidth;
    ~~size_auto_chooser~~
    return 'thumbnails-~~default_size~~-0.html';
}

window.location.href = getPreferredSize();

        </script>

        <meta http-equiv="refresh" content="0.1;url=thumbnails-~~default_size~~-nojs-0.html">
</html>
EOF


$index_head_code = '<meta name="generator" content="Booh-' + $VERSION + ' http://booh.org/"/>
<script language="JavaScript1.1" type="text/JavaScript">
function init() {
    if (!document.cookie || document.cookie.indexOf("booh-not-a-newbie") == -1) {
        document.getElementById("title").innerHTML += "<br/><br/>' + utf8(_("<i>Hint: you can click on the images to open the albums!</i>")) + '";
    }
    var expires = new Date(new Date().getTime() + (10 * 86400000));  // 10 days
    document.cookie = "booh-not-a-newbie=true"
                      + "; expires=" + expires.toGMTString()
                      + "; path=/";
}
</script>'
